﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Wisej.Core;
using Wisej.Web;

namespace C1.Web.Ext.C1Combo
{
    public class C1Combo : Widget
    {


        public override string InitScript
        {
            get
            {
                return BuildInitScript();
            }
            set
            {
                base.InitScript = value;
            }
        }


        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override List<Package> Packages
        {
            get
            {

                if (base.Packages.Count == 0)
                {
                    base.Packages.Add(new Package()
                    {
                        Name = "wijmo",
                        Source = GetResourceURL("C1.Web.Ext.C1Combo.JavaScript.wijmo.min.js")
                    });

                    //base.Packages.Add(new Package()
                    //{
                    //    Name = "wijmo.style",
                    //    Source = GetResourceURL("C1.Web.Ext.C1Combo.Styles.wijmo.min.css")
                    //});



                    // initialize the loader with the required libraries.
                    base.Packages.Add(new Package()
                    {
                        Name = "wijmo.input",
                        Source = GetResourceURL("C1.Web.Ext.C1Combo.JavaScript.wijmo.input.min.js")
                    });


                }


                return base.Packages;
            }
        }

        private string BuildInitScript()
        {

            dynamic options = new DynamicObject();
            string script = GetResourceString("C1.Web.Ext.C1Combo.JavaScript.startup.js");

            //// use ToString() in this case to keep the name uppercase first.
            //// Wisej JSON serializer always lowers the first character to keep with javascript naming convention.
            //options.skinId = this.Skin.ToString();

            //options.tickDelay = this.TickDelay;
            //options.longTickDelay = this.LongTickDelay;
            //options.showSecondHand = this.ShowSecondHand;
            //options.showDigital = this.ShowDigital;
            //options.gmtOffset = this.GmtOffset;
            //options.logClock = this.ClockType == CoolClockType.Logarithmic;
            //options.logClockRev = this.ClockType == CoolClockType.LogarithmicReversed;
            //options.displayRadius =
            //    this.Width < this.Height
            //        ? this.Width / 2
            //        : this.Height / 2;

            //script = script.Replace("$options", options.ToString());

            return script;
        }

    }
}
